(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.spaceTrim = {}));
})(this, (function (exports) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function topTrim(str) {
        var e_1, _a;
        var linesWithContent = [];
        var contentStarted = false;
        var lines = str.split('\n');
        try {
            for (var lines_1 = __values(lines), lines_1_1 = lines_1.next(); !lines_1_1.done; lines_1_1 = lines_1.next()) {
                var line = lines_1_1.value;
                if (line.trim() !== '') {
                    contentStarted = true;
                }
                if (contentStarted) {
                    linesWithContent.push(line);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (lines_1_1 && !lines_1_1.done && (_a = lines_1.return)) _a.call(lines_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return linesWithContent.join('\n');
    }

    function verticalTrim(str) {
        str = topTrim(str);
        str = topTrim(str.split('\n').reverse().join('\n'))
            .split('\n')
            .reverse()
            .join('\n');
        return str;
    }

    function spaceTrim(str /* TODO: , char: RegExp = /\s/*/) {
        // ✂️ Trimming from top and bottom
        str = verticalTrim(str);
        // ✂️ Trimming from left and right
        var lines = str.split('\n');
        var lineStats = lines
            .filter(function (line) { return line.trim() !== ''; })
            .map(function (line) {
            var contentStart = line.length - line.trimLeft().length;
            var contentEnd = contentStart + line.trim().length;
            return { contentStart: contentStart, contentEnd: contentEnd };
        });
        if (lineStats.length === 0) {
            return '';
        }
        var _a = lineStats.reduce(
        // tslint:disable-next-line: no-shadowed-variable
        function (_a, _b) {
            var minContentStart = _a.minContentStart, maxContentEnd = _a.maxContentEnd;
            var contentStart = _b.contentStart, contentEnd = _b.contentEnd;
            return ({
                minContentStart: Math.min(minContentStart, contentStart),
                maxContentEnd: Math.max(maxContentEnd, contentEnd),
            });
        }, {
            minContentStart: lineStats[0].contentStart,
            maxContentEnd: lineStats[0].contentEnd,
        }), minContentStart = _a.minContentStart, maxContentEnd = _a.maxContentEnd;
        str = lines
            .map(function (line) { return line.substring(minContentStart, maxContentEnd); })
            .join('\n');
        return str;
    }

    exports["default"] = spaceTrim;
    exports.spaceTrim = spaceTrim;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=spaceTrim.js.map
